<?php

namespace Modules\Pp\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;
class DailyCollection extends Model
{
    use HasFactory,LogsActivity;

    protected $table = 'pp_collection_plan';
    protected $primaryKey = 'collection_plan_id';
    public $incrementing = false;
    protected $keyType = 'string';
    protected static $logAttributes = [
        'collection_plan_id',
        'product_id',
        'plan_date',
        'quantity',
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "pp_collection_plan";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }
}
