<?php

namespace Modules\Pp\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;
class EmployeeSite extends Model
{
    use HasFactory,LogsActivity;

    protected $table = 'hr_employee_sites';
    protected $primaryKey = 'site_id';
    public $incrementing = false;
    protected static $logAttributes = [
        'site_id',
        'site',
        'status',
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "hr_employee_sites";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }

}
